C++在线运行

版本:

所属目录
点击了解高性能代码运行API
运行结果
教程手册
代码仓库
极速运行
交互输入
极速运行模式,更高效的运行,点击编辑器上方的运行按钮即刻体验吧。
以下是用户最新保存的代码
钱币找零问题 发布于:2022-11-10 21:10 分糖果的问题 发布于:2022-11-11 21:02 二分查找的变形 发布于:2022-11-08 10:24 二分查找的实现 发布于:2022-11-08 10:24 二分查找的变形 发布于:2022-11-08 09:10 基数排序的过程 发布于:2022-11-07 21:22 二分查找的实现 发布于:2022-11-07 21:11 基数排序的代码实现 发布于:2022-11-08 14:44 二分查找的变形 发布于:2022-11-07 19:50 二分查找的代码 发布于:2022-11-07 19:47 基数排序的全过程 发布于:2022-11-07 19:46 测试类的继承,构造等 发布于:2022-11-07 19:16 一个跳动的爱心 发布于:2022-11-07 14:57 二分查找。 发布于:2022-11-07 09:54 二分查找,变! 发布于:2022-11-07 09:51 基数排序。 发布于:2022-11-07 09:13 二分查找代码 发布于:2022-11-07 03:47 基数排序代码 发布于:2022-11-07 03:42 二分查找以及四种变形的实现 发布于:2022-11-07 00:05 跳格子 每次能跳2^k个格子,求n个格子共有几种跳法。 规律:let m = [log(2,n)] ([x]表示取不大于x的整数部分) f(n) = Σ(i=0,m)f(n-2^i) 发布于:2022-11-09 21:32 基数排序实现 发布于:2022-11-06 20:48 求有限整数列中的最大值 发布于:2022-11-10 12:38 二分查找的变形。 发布于:2022-11-06 13:48 二分查找7的位置。 发布于:2022-11-06 13:30 关于雅克比迭代, 高斯塞德尔迭代以及SOR迭代的C++实现 发布于:2022-11-06 00:32 iowildfidf ddsauhio 发布于:2022-11-05 20:46 一个简单的东西 发布于:2022-11-05 19:50 组合 要求m个正整数相加的和为n,输出满足这个条件的正整数组合有多少。 发布于:2022-11-05 19:34 smfghjhfkjewhghje w 发布于:2022-11-05 19:38 贪心算法求解背包问题 发布于:2022-11-06 10:50 基数排序3 44 38 5 47 15 36 26 27 2 46 4 19 50 48 发布于:2022-11-05 16:22 通过栈实现 1.括号匹配 2.中缀表达式转后缀表达式 3.后缀表达式计算(结果大于10入栈会有问题,还需后续优化) 发布于:2022-11-05 11:43 n个数不相邻的组合数 发布于:2022-11-04 21:32 指针和别名的常量转换const_cast均无法改变数字常量的原值,但可以改变文字变量型常量,如aa=cc 发布于:2022-11-04 16:52 文字常量 与数字常量的 const_cast 发布于:2022-11-04 16:41 计算a1+(n-1)*(a2-a1)结果 发布于:2022-11-04 16:17 课上练习 转换构造函数 发布于:2022-11-04 11:11 查找IP地址的所属地 发布于:2022-11-03 21:28 查找IP地址的所属地 发布于:2022-11-03 21:18 二分查找的变形 发布于:2022-11-03 21:18 二分查找的变形 发布于:2022-11-03 21:04 计数排序算法 发布于:2022-11-03 20:58 桶排序算法 发布于:2022-11-03 20:55 二分查找的代码 发布于:2022-11-03 20:45 二分查找的代码 发布于:2022-11-03 20:46 基数排序的实现 发布于:2022-11-03 20:24 桶排序代码。 发布于:2022-11-03 20:14 算法实验课 发布于:2022-11-03 19:41 顺序表代码 发布于:2022-11-03 19:19 豆子装包问题 发布于:2022-11-11 20:30 [更多]
显示目录

异常处理



C++ 异常处理

异常是程序在执行期间产生的问题。C++ 异常是指在程序运行时发生的特殊情况,比如尝试除以零的操作。

异常提供了一种转移程序控制权的方式。C++ 异常处理涉及到三个关键字:try、catch、throw

  • throw: 当问题出现时,程序会抛出一个异常。这是通过使用 throw 关键字来完成的。
  • catch: 在您想要处理问题的地方,通过异常处理程序捕获异常。catch 关键字用于捕获异常。
  • try: try 块中的代码标识将被激活的特定异常。它后面通常跟着一个或多个 catch 块。

如果有一个块抛出一个异常,捕获异常的方法会使用 trycatch 关键字。try 块中放置可能抛出异常的代码,try 块中的代码被称为保护代码。使用 try/catch 语句的语法如下所示:

try
{
   // 保护代码
}catch( ExceptionName e1 )
{
   // catch 块
}catch( ExceptionName e2 )
{
   // catch 块
}catch( ExceptionName eN )
{
   // catch 块
}

如果 try 块在不同的情境下会抛出不同的异常,这个时候可以尝试罗列多个 catch 语句,用于捕获不同类型的异常。

抛出异常

您可以使用 throw 语句在代码块中的任何地方抛出异常。throw 语句的操作数可以是任意的表达式,表达式的结果的类型决定了抛出的异常的类型。

以下是尝试除以零时抛出异常的实例:

double division(int a, int b)
{
   if( b == 0 )
   {
      throw "Division by zero condition!";
   }
   return (a/b);
}

捕获异常

catch 块跟在 try 块后面,用于捕获异常。您可以指定想要捕捉的异常类型,这是由 catch 关键字后的括号内的异常声明决定的。

try
{
   // 保护代码
}catch( ExceptionName e )
{
  // 处理 ExceptionName 异常的代码
}

上面的代码会捕获一个类型为 ExceptionName 的异常。如果您想让 catch 块能够处理 try 块抛出的任何类型的异常,则必须在异常声明的括号内使用省略号 ...,如下所示:

try
{
   // 保护代码
}catch(...)
{
  // 能处理任何异常的代码
}

下面是一个实例,抛出一个除以零的异常,并在 catch 块中捕获该异常。

#include <iostream>
using namespace std;

double division(int a, int b) {
   if( b == 0 )
   {
      throw "Division by zero condition!";
   }
   return (a/b);
}

int main () {
   int x = 50;
   int y = 0;
   double z = 0;

   try {
     z = division(x, y);
     cout << z << endl;
   }catch (const char* msg) {
     cerr << msg << endl;
   }

   return 0;
}

由于我们抛出了一个类型为 const char* 的异常,因此,当捕获该异常时,我们必须在 catch 块中使用 const char*。当上面的代码被编译和执行时,它会产生下列结果:

Division by zero condition!

C++ 标准的异常

C++ 提供了一系列标准的异常,定义在 <exception> 中,我们可以在程序中使用这些标准的异常。它们是以父子类层次结构组织起来的,如下所示:

C++ 异常的层次结构

下表是对上面层次结构中出现的每个异常的说明:

异常 描述
std::exception 该异常是所有标准 C++ 异常的父类。
std::bad_alloc 该异常可以通过 new 抛出。
std::bad_cast 该异常可以通过 dynamic_cast 抛出。
std::bad_exception 这在处理 C++ 程序中无法预期的异常时非常有用。
std::bad_typeid 该异常可以通过 typeid 抛出。
std::logic_error 理论上可以通过读取代码来检测到的异常。
std::domain_error 当使用了一个无效的数学域时,会抛出该异常。
std::invalid_argument 当使用了无效的参数时,会抛出该异常。
std::length_error 当创建了太长的 std::string 时,会抛出该异常。
std::out_of_range 该异常可以通过方法抛出,例如 std::vector 和 std::bitset<>::operator
std::runtime_error 理论上不可以通过读取代码来检测到的异常。
std::overflow_error 当发生数学上溢时,会抛出该异常。
std::range_error 当尝试存储超出范围的值时,会抛出该异常。
std::underflow_error 当发生数学下溢时,会抛出该异常。

定义新的异常

您可以通过继承和重载 exception 类来定义新的异常。下面的实例演示了如何使用 std::exception 类来实现自己的异常:

#include <iostream>
#include <exception>
using namespace std;

struct MyException : public exception
{
  const char * what () const throw () {
    return "C++ Exception";
  }
};

int main() {
  try
  {
    throw MyException();
  }
  catch(MyException& e)
  {
    std::cout << "MyException caught" << std::endl;
    std::cout << e.what() << std::endl;
  }
  catch(std::exception& e)
  {
    //其他的错误
  }
}

这将产生以下结果:

MyException caught
C++ Exception

在这里,what() 是异常类提供的一个公共方法,它已被所有子异常类重载。这将返回异常产生的原因。

由JSRUN为你提供的C++在线运行、在线编译工具
        JSRUN提供的C++ 在线运行,C++ 在线运行工具,基于linux操作系统环境提供线上编译和线上运行,具有运行快速,运行结果与常用开发、生产环境保持一致的特点。

title

使用此草稿 删除草稿

  • 00:23
注册登录后可减少验证码的弹出,点击前往 注册 | 登录

皮肤:

运行模式:

嵌入代码 iframe嵌入:


服务器已安装大部分常用的依赖库,但仍会存在一些未被安装的库, 可以通过本窗口立即安装所需依赖库,请确保库名正确,否则无法安装成功。


请输入依赖库的名称:

请选择语言: